// Copyright (c) 1999, 2000
//      Maurice Castro (maurice@serc.rmit.edu.au)
//      All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 
// This software is provided by the original author and contributors ``as
// is'' and any express or implied warranties, including, but not limited
// to, the implied warranties of merchantability and fitness for a
// particular purpose are disclaimed.  In no event shall the authors or
// contributors be liable for any direct, indirect, incidental, special,
// exemplary, or consequential damages (including, but not limited to,
// procurement of substitute goods or services; loss of use, data, or
// profits; or business interruption) however caused and on any theory of
// liability, whether in contract, strict liability, or tort (including
// negligence or otherwise) arising in any way out of the use of this
// software, even if advised of the possibility of such damage.
//
// $Id: cmdio.java,v 1.4 2000/02/01 05:01:34 maurice Exp $


package cmd;
import java.util.*;
import java.io.*;

public class cmdio 
{
	InputStream in;
	String prompt;
	public cmdio(InputStream in)
	{
		this.in = in;
		this.prompt = null;
	}
	public String readLine() throws java.io.IOException
	{
		StringBuffer s = new StringBuffer();
		char c;
		c = (char) in.read();
		while (c != '\n')
		{
			if (c == '\b')
			{
				if (s.length() > 0)
				{
					s.setLength(s.length()-1);
					System.out.print(" \b");
				}
				else
				{
					if (this.prompt != null)
					{
						System.out.print(prompt.substring(prompt.length()-1));
					}
				}
			}
			else
			{
				s.append(c);
			}
			c = (char) in.read();
		}
		return(s.toString());
	}
	public String readLine(StringTokenizer st, String prompt) throws java.io.IOException
	{
		String s;
		if (st.hasMoreTokens())
			s = st.nextToken();
		else
		{
			s = readLine(prompt);
		}
		return(s);
	}
	public String readLine(String prompt) throws java.io.IOException
	{
		String s;
		System.out.print(prompt);
		this.prompt = prompt;
		s = readLine();
		this.prompt = null;
		return(s);
	}
	public String getPass(String prompt) throws java.io.IOException
	{
		System.out.print(prompt);
		StringBuffer s = new StringBuffer();
		char c;
		c = (char) in.read();
		while (c != '\n')
		{
			// psion method for obscuring passwords
			if (c == '\b') 
			{
				if (s.length() > 0)
				{
					s.setLength(s.length()-1);
					System.out.print(" \b");
				}
				else
				{
					System.out.print(prompt.substring(prompt.length()-1));
				}
			}
			else
			{
				System.out.print("\b*");
				s.append(c);
			}
			c = (char) in.read();
		}
		return(s.toString());
	}
}
