// Copyright (c) 1999, 2000
//      Maurice Castro (maurice@serc.rmit.edu.au)
//      All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 
// This software is provided by the original author and contributors ``as
// is'' and any express or implied warranties, including, but not limited
// to, the implied warranties of merchantability and fitness for a
// particular purpose are disclaimed.  In no event shall the authors or
// contributors be liable for any direct, indirect, incidental, special,
// exemplary, or consequential damages (including, but not limited to,
// procurement of substitute goods or services; loss of use, data, or
// profits; or business interruption) however caused and on any theory of
// liability, whether in contract, strict liability, or tort (including
// negligence or otherwise) arising in any way out of the use of this
// software, even if advised of the possibility of such damage.
//
// $Id: helpcmd.java,v 1.3 2000/01/18 04:54:23 maurice Exp $


package cmd;
import java.util.*;

public class helpcmd extends Cmd
{
	static Hashtable cmds;
	static int numCols = 6;
	public helpcmd(Hashtable cmdht)
	{
		cmds = cmdht;
	}
	public String help(String cmd)
	{
		return(cmd + " [command]");
	}
	public void exec(StringTokenizer st)
	{
		if (st.hasMoreTokens())
		{
			String command = st.nextToken();
			System.out.print("Help " + command + "\n\n\t");
			System.out.println(((cmd.Cmd) cmds.get(command)).help(command));
			System.out.println();
		}
		else
		{
			System.out.println("Small Ftp client for Psion series 5");
			System.out.println();
			System.out.println("Available commands:");
			System.out.println();
			if (cmds.isEmpty())
			{
				System.out.println("No Commands Defined!");
				System.out.println();
				return;
			}
			Enumeration cmdnames = cmds.keys();
			int col = 1;
			while (cmdnames.hasMoreElements())
			{
				System.out.print("\t");
				System.out.print(cmdnames.nextElement());
				if (col % numCols != 0)
				{
					col = col + 1;
				}
				else
				{
					System.out.println();
					col = 1;
				}
			}
			System.out.println();
		}
	}
}
