// Copyright (c) 1999, 2000
//      Maurice Castro (maurice@serc.rmit.edu.au)
//      All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 
// This software is provided by the original author and contributors ``as
// is'' and any express or implied warranties, including, but not limited
// to, the implied warranties of merchantability and fitness for a
// particular purpose are disclaimed.  In no event shall the authors or
// contributors be liable for any direct, indirect, incidental, special,
// exemplary, or consequential damages (including, but not limited to,
// procurement of substitute goods or services; loss of use, data, or
// profits; or business interruption) however caused and on any theory of
// liability, whether in contract, strict liability, or tort (including
// negligence or otherwise) arising in any way out of the use of this
// software, even if advised of the possibility of such damage.
//
// $Id: mgetcmd.java,v 1.3 2000/01/18 04:54:24 maurice Exp $


package cmd;
import java.util.*;
import java.io.*;
import ftp.ftp;

public class mgetcmd extends getcmd
{
	public mgetcmd(ftp ftp, StringBuffer cwd, cmd.cmdio inStream)
	{
		super(ftp, cwd, inStream);
	}
	public String help(String cmd)
	{
		return(cmd + " [file_name ...]");
	}
	public void exec(StringTokenizer st) throws java.io.IOException
	{
		StringBuffer filenames;
		String pattern  = inStream.readLine(st, "(remote-files): ");
		filenames = listFiles(pattern);
		while (st.hasMoreTokens())
		{
			pattern  = st.nextToken();
			filenames.append(listFiles(pattern));
		}
		getFiles(filenames);
	}
	private void getFiles(StringBuffer filenames) throws java.io.IOException
	{
		StringTokenizer tok = new StringTokenizer(filenames.toString(), "\n");
		while(tok.hasMoreTokens())
		{
			getFile(tok.nextToken());
		}
	}
	private StringBuffer listFiles(String filePattern) throws java.io.IOException
	{
		StringBuffer sb = new StringBuffer();
		BufferedReader ftpin;
		ftp.getDataSock();
		if (!ftp.isPositiveCompletion()) 
		{
			return(sb);
		}
		ftpin = ftp.list(filePattern);
		if (!ftp.isPositivePreliminary()) 
		{
			return(sb);
		}
		String s;
		s = ftpin.readLine();
		while (s != null)
		{
			sb.append(s + "\n");
			s = ftpin.readLine();
		}
		ftp.closeDataSock();
		ftp.getResponse();
		return(sb);
	}
}
