// Copyright (c) 1999, 2000
//      Maurice Castro (maurice@serc.rmit.edu.au)
//      All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 
// This software is provided by the original author and contributors ``as
// is'' and any express or implied warranties, including, but not limited
// to, the implied warranties of merchantability and fitness for a
// particular purpose are disclaimed.  In no event shall the authors or
// contributors be liable for any direct, indirect, incidental, special,
// exemplary, or consequential damages (including, but not limited to,
// procurement of substitute goods or services; loss of use, data, or
// profits; or business interruption) however caused and on any theory of
// liability, whether in contract, strict liability, or tort (including
// negligence or otherwise) arising in any way out of the use of this
// software, even if advised of the possibility of such damage.
//
// $Id: putcmd.java,v 1.3 2000/01/18 04:54:25 maurice Exp $


package cmd;
import java.util.*;
import java.io.*;
import ftp.ftp;

public class putcmd extends Cmd
{
	protected ftp ftp;
	protected cmd.cmdio inStream;
	protected char type;
	protected StringBuffer cwd;
	public putcmd(ftp ftp, StringBuffer cwd, cmd.cmdio inStream)
	{
		this.ftp = ftp;
		this.inStream = inStream;
		this.cwd = cwd;
	}
	public String help(String cmd)
	{
		return(cmd + " [file_name]");
	}
	public void exec(StringTokenizer st) throws java.io.IOException
	{
		String file = inStream.readLine(st, "(local-file): ");
		putFile(file);
	}
	public void putFile(String file) throws java.io.IOException
	{
		// open a local file 
		File ifile = new File(cwd.toString(), file);
		FileInputStream istream = new FileInputStream(ifile);
		// open connection
		ftp.getDataSock();
		if (!ftp.isPositiveCompletion()) 
		{
			System.out.println(ftp.getMessage());
			return;
		}
		OutputStream ftpout;
		ftpout = ftp.store(file);
		System.out.println(ftp.getMessage());
		if (!ftp.isPositivePreliminary()) 
		{
			return;
		}
		// at this point we have a file ready to transfer
		byte[] buf = new byte[1024];
		int nbytes;
		// read data and write it to new file
		nbytes = istream.read(buf, 0, 1024);
		while (nbytes != -1)
		{
			ftpout.write(buf, 0, nbytes);
			nbytes = istream.read(buf, 0, 1024);
		}
		istream.close();
		ftp.closeDataSock();
		ftp.getResponse();
		System.out.println(ftp.getMessage());
		if (!ftp.isPositiveCompletion()) 
		{
			System.out.println("Put failed.");
			return;
		}
	}
}
