// Copyright (c) 2000
//      Maurice Castro (maurice@serc.rmit.edu.au)
//      All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 
// This software is provided by the original author and contributors ``as
// is'' and any express or implied warranties, including, but not limited
// to, the implied warranties of merchantability and fitness for a
// particular purpose are disclaimed.  In no event shall the authors or
// contributors be liable for any direct, indirect, incidental, special,
// exemplary, or consequential damages (including, but not limited to,
// procurement of substitute goods or services; loss of use, data, or
// profits; or business interruption) however caused and on any theory of
// liability, whether in contract, strict liability, or tort (including
// negligence or otherwise) arising in any way out of the use of this
// software, even if advised of the possibility of such damage.
//
// $Id: lclhst.java,v 1.4 2000/01/21 08:00:29 maurice Exp $

import java.util.*;
import java.io.*;
import java.net.*;

public class lclhst 
{
	public native String LocalName();

	static boolean initialised = false;
	static boolean haveJni = false;
	static boolean needJni = true;

	public lclhst()
	{
		if (!initialised)
		{
			initialised = true;
			needJni = testNeedJni();
			if (needJni)
			{
				try
				{
					System.load("\\System\\Apps\\pjftp\\lclhst.dll");
				}
				catch (java.lang.Error e)
				{
					System.out.println("localhost unavailable: passive mode only\n");
					haveJni = false;
					return;
				}
				haveJni = true;
			}
		}
	}

	private boolean testNeedJni()
	{
		String os = System.getProperty("os.name");
		if (os.equals("EPOC"))
		{
			return true;
		}
		return false;
	}

	public boolean available()
	{
		if (!needJni)
			return true;
		if (haveJni)
			return true;
		return false;
	}

	public String localhost()
	{
		String host;
		if (!needJni)
		{
			try 
			{
				host = InetAddress.getLocalHost().getHostAddress();
			}
			catch (java.net.UnknownHostException e)
			{
				host = "";
			}
		}
		else
		{
			if (haveJni)
			{
				host = LocalName();
			}
			else
			{
				host = "";
			}
		}
		return(host);
	}
}
